import JdgSound; 

class JdgSoundHandler {

	static function jdgSoundHandler() {

	//*******************************************************************
	trace(" Creating sound handler object on _level0");
	
	var jdgSoundHandMC:MovieClip;
	jdgSoundHandMC = _level0.createEmptyMovieClip('jdgSoundHandMC', 7676);
	
	jdgSoundHandMC.soundPlaying = true;
	jdgSoundHandMC.fadedVolume = 10;
	jdgSoundHandMC.fadeDuration = 31;
	jdgSoundHandMC.fadeFastDuration = 10;
	jdgSoundHandMC.queuedSound = null;
	jdgSoundHandMC.soundLoadQueue = [];
	jdgSoundHandMC.soundList = [];
	
	jdgSoundHandMC.loadQueuedSound = function() {
		trace('loadQueuedSound');
		if (jdgSoundHandMC.queuedSound != null) {
			trace('loaded queuedSound: ' + jdgSoundHandMC.queuedSound.sourcename);
			if (jdgSoundHandMC.queuedSound.ambient) {
				jdgSoundHandMC.queuedSound.setVolume(jdgSoundHandMC.queuedSound.fullVolume);
				jdgSoundHandMC.queuedSound.start(.025,1000);
				jdgSoundHandMC.queuedSound.playing = true;
			}
		}
		if (this.soundLoadQueue.length > 0) {
			trace('soundLoadQueue.length: ' + this.soundLoadQueue.length);
			jdgSoundHandMC.queuedSound = this.soundLoadQueue.pop();
//			jdgSoundHandMC.queuedSound = qs;
			if (jdgSoundHandMC.queuedSound.external) {
				trace('loading queuedSound: ' + jdgSoundHandMC.queuedSound.sourcename);
				jdgSoundHandMC.queuedSound.onLoad = this.loadQueuedSound;
				jdgSoundHandMC.queuedSound.loadSound(jdgSoundHandMC.queuedSound.sourcename);
			} else {
				trace('attaching queuedSound: ' + jdgSoundHandMC.queuedSound.sourcename);
				jdgSoundHandMC.queuedSound.attachSound(jdgSoundHandMC.queuedSound.sourcename);
				this.loadQueuedSound();
			}
		}
	}
	
	// jdgSoundHandMC.soundList [id, sourcename, external, looping, ambient, fadeVolume, fullVolume]
	jdgSoundHandMC.soundList.push(['loop','sn_loop_2008.mp3',true,true,true,25,70]);

	for (var i:Number=0; i<jdgSoundHandMC.soundList.length; i++) {
		jdgSoundHandMC['sound_' + jdgSoundHandMC.soundList[i][0]] = new JdgSound(_level0);
		var sRef:JdgSound = jdgSoundHandMC['sound_' + jdgSoundHandMC.soundList[i][0]];
		sRef.sourcename = jdgSoundHandMC.soundList[i][1];
		sRef.external = jdgSoundHandMC.soundList[i][2];
		sRef.looping = jdgSoundHandMC.soundList[i][3];
		sRef.ambient = jdgSoundHandMC.soundList[i][4];
		sRef.fadeVolume = jdgSoundHandMC.soundList[i][5];
		sRef.fullVolume = jdgSoundHandMC.soundList[i][6];
		jdgSoundHandMC.soundLoadQueue.push(sRef);
		jdgSoundHandMC.soundList[i] = sRef;
	}
	
	jdgSoundHandMC.unfadeSounds = function() {
		trace('unfadeSounds');
		for (var i in jdgSoundHandMC.soundList) {
			jdgSoundHandMC.soundList[i].setVolume(jdgSoundHandMC.soundList[i].fullVolume);
		}
	}
	
	jdgSoundHandMC.fadeSounds = function(dir) { // 'in', 'out'
		trace('fadeSounds: ' + dir);
		this.direction = dir;
		this.fadeSteps = this.fadeDuration;
		this.stepCount = 0;
		this.fadeList = [];
		for (var i in this.soundList) {
			if (this.soundList[i].fadeVolume < this.soundList[i].fullVolume) {
				var tVol:Number = (dir == 'in') ? this.soundList[i].fullVolume : this.soundList[i].fadeVolume;
				this.fadeList.push([this.soundList[i], this.soundList[i].getVolume(), tVol]);
			}
		}
		this.onEnterFrame = function() { this.fadeStep() };
	}
	
	jdgSoundHandMC.fadeStep = function() {
		if (this.stepCount <= this.fadeSteps) {
			for (var i in this.fadeList) {
				var newVol:Number = this.fadeList[i][1] + ((this.fadeList[i][2] - this.fadeList[i][1]) * this.stepCount/this.fadeSteps);
				this.fadeList[i][0].setVolume(newVol);
			}
			this.stepCount ++;
		} else {
			for (var i in this.fadeList) {
				this.fadeList[i][0].setVolume(this.fadeList[i][2]);
			}
			this.onEnterFrame = null;
			delete this.fadeList;
			delete this.stepCount;
			delete this.fadeSteps;
			if (this.stopAfterFade) {
				jdgSoundHandMC.stopSoundtrack();
				delete this.stopAfterFade;
			}
		}
	}
	
	jdgSoundHandMC.fadeOutFast = function() {
		trace('fadeOutFast');
		this.fadeSteps = this.fadeFastDuration;
		this.stepCount = 0;
		this.fadeList = [];
		this.stopAfterFade = true;
		for (var i in this.soundList) {
			if (this.soundList[i].fadeVolume < this.soundList[i].fullVolume) {
				var tVol = 0;
				this.fadeList.push([this.soundList[i],this.soundList[i].getVolume(), tVol]);
			}
		}
		this.onEnterFrame = function() { this.fadeStep() };
	}
	
	jdgSoundHandMC.startSoundtrack = function() {
	trace('startSoundtrack');
	if (!this.soundPlaying) {
			for (var i in this.soundList) {
				if (!this.soundList[i].playing && this.soundList[i].ambient) {
					if (this.soundList[i].getVolume() == 0) {
						this.soundList[i].setVolume(this.soundList[i].fullVolume);
					}
					this.soundList[i].start(0,1000);
					this.soundList[i].playing = true;
				}
			}
			this.soundPlaying = true;
		}
	}
	
	jdgSoundHandMC.stopSoundtrack = function() {
	trace('stopSoundtrack');
		for (var i in jdgSoundHandMC.soundList) {
			this.soundList[i].stop();
			this.soundList[i].playing = false;
		}
		this.soundPlaying = false;
	}
	
	jdgSoundHandMC.toggleSound = function() {
	trace('toggleSound');
		if (this.soundPlaying) {
			this.stopSoundtrack();
		} else {
			this.startSoundtrack();
		}
	}

}	
}